#递增式特征选择
import numpy as np
import numpy
import pandas as pd
import tensorflow.keras
from tensorflow.keras.layers import Reshape
from tensorflow.keras.layers import Dense,Input, Dropout, GRU
from tensorflow.keras.layers import Bidirectional,GlobalAveragePooling1D
from tensorflow.keras.models import Sequential,Model
from tensorflow.keras import layers
import tensorflow as tf
from tensorflow import keras
from sklearn.model_selection import StratifiedKFold

#Load data
file_path_full_training_set = 'FS_Data/train_data.csv'
file_path_full_test_set1 = 'FS_Data/validation_0.7.csv'
file_path_full_test_set = 'FS_Data/test_data.csv'

train_data=pd.read_csv(file_path_full_training_set)
test_data=pd.read_csv(file_path_full_test_set)
test_data1=pd.read_csv(file_path_full_test_set1)

# # binary label
# train_data['attack_class'] = train_data['attack_class'].replace([0], [0])
# train_data['attack_class'] = train_data['attack_class'].replace([1], [1])
# train_data['attack_class'] = train_data['attack_class'].replace([2], [1])
# train_data['attack_class'] = train_data['attack_class'].replace([3], [1])
# train_data['attack_class'] = train_data['attack_class'].replace([4], [1])
#
# # test_data['attack_class'] = test_data['attack_class'].replace([0], [0])
# # test_data['attack_class'] = test_data['attack_class'].replace([1], [1])
# # test_data['attack_class'] = test_data['attack_class'].replace([2], [1])
# # test_data['attack_class'] = test_data['attack_class'].replace([3], [1])
# # test_data['attack_class'] = test_data['attack_class'].replace([4], [1])
#
# test_data1['attack_class'] = test_data1['attack_class'].replace([0], [0])
# test_data1['attack_class'] = test_data1['attack_class'].replace([1], [1])
# test_data1['attack_class'] = test_data1['attack_class'].replace([2], [1])
# test_data1['attack_class'] = test_data1['attack_class'].replace([3], [1])
# test_data1['attack_class'] = test_data1['attack_class'].replace([4], [1])

drop_cols = train_data.loc[:,[i for i in list(train_data.columns) if i in [
'dst_host_srv_count',
'dst_host_same_srv_rate',
'is_guest_login',
]]]
train_data.drop(drop_cols, axis=1, inplace=True)

drop_cols1 =test_data.loc[:,[i for i in list(test_data.columns) if i in [
'dst_host_srv_count',
'dst_host_same_srv_rate',
'is_guest_login',
]]]
test_data.drop(drop_cols1, axis=1, inplace=True)

from sklearn.model_selection import train_test_split
# Divide the dataset into training and validation sets: with a ratio of 0.7 for training and 0.3 for validation
# train_data=pd.concat([train_data,test_data1],axis=0)
# training, testing = train_test_split(train_data,test_size=0.3, random_state=1)
# training.to_csv('./train_data.csv',index=False)
# testing.to_csv('./test_data.csv',index=False)
X_train=train_data.drop('attack_class',axis=1)
y_train=train_data['attack_class']
X_test=test_data.drop('attack_class',axis=1)
y_test=test_data['attack_class']

class TransformerEncoder(layers.Layer):
    def __init__(self, embed_dim, dense_dim, num_heads, rate=0.1,bias=False,**kwargs):
        super().__init__(**kwargs)
        self.embed_dim = embed_dim
        self.dense_dim = dense_dim
        self.num_heads = num_heads
        self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        self.attention = layers.MultiHeadAttention(num_heads=num_heads, key_dim=embed_dim)
        self.dense_proj = keras.Sequential(
            [layers.Dense(dense_dim, activation="relu"),layers.Dense(embed_dim),] )
        self.layernorm_1 = layers.LayerNormalization()
        self.layernorm_2 = layers.LayerNormalization()
        self.dropout1 = layers.Dropout(rate)
        self.dropout2 = layers.Dropout(rate)

    def call(self, inputs, mask=None):
        if mask is not None:
            mask = mask[:, tf.newaxis, :]
        attention_output = self.attention(inputs, inputs, attention_mask=mask)
        proj_input = self.layernorm_1(inputs + attention_output)
        proj_output = self.dense_proj(proj_input)
        return self.layernorm_2(proj_input + proj_output)

    def get_config(self):
        config = super().get_config()
        config.update({
            "embed_dim": self.embed_dim,
            "num_heads": self.num_heads,
            "dense_dim": self.dense_dim, })
        return config

def create_model(X_train):
    # BIGRU+ATTENTION
    batch_size = 128
    inputs = Input(name='inputs', shape=[X_train.shape[1], 1], dtype='float64')
    x = Bidirectional(GRU(64, return_sequences=True))(inputs)
    x = Dense(64, activation='relu')(x)
    x = Dropout(0.5)(x)
    x = TransformerEncoder(64, 64, 2)(x)
    x = GlobalAveragePooling1D()(x)
    x = Reshape((64, 1), input_shape=(64,))(x)
    x = Bidirectional(GRU(32))(x)
    x = Dense(32, activation='relu')(x)
    x = Dropout(0.5)(x)
    output = Dense(5, activation='softmax')(x)
    model = Model(inputs=[inputs], outputs=output)
    adam = tf.keras.optimizers.Adam(lr=0.001, beta_1=0.9, beta_2=0.999, epsilon=1e-08)
    model.compile(loss='categorical_crossentropy', optimizer=adam, metrics=['accuracy'])
    # model.compile(loss='binary_crossentropy', optimizer=adam, metrics=['accuracy'])
    # print(model.summary())
    return model

y_train = tensorflow.keras.utils.to_categorical(y_train, num_classes=5)
y_test = tensorflow.keras.utils.to_categorical(y_test, num_classes=5)
y_train = np.reshape(y_train, (y_train.shape[0], -1))
y_test = np.reshape(y_test, (y_test.shape[0], -1))

def IFS(X_train,X_test):
    final_acc = []
    for i in range(1, 32):
        avg_acc = []
        data_X = X_train.iloc[:, :i]
        test_data_X=X_test.iloc[:,:i]
        print(data_X.shape)

        model = create_model(data_X)

        data_X=data_X.to_numpy()
        test_data_X=test_data_X.to_numpy()
        data_X=np.reshape(data_X,(data_X.shape[0],data_X.shape[1],-1))
        test_data_X=np.reshape(test_data_X,(test_data_X.shape[0],test_data_X.shape[1],-1))

        model.fit(data_X, y_train, epochs=1, batch_size=128,verbose=0)
        acc = model.evaluate(test_data_X, y_test)
        accuracy=acc[1]

        final_acc.append(accuracy)

    print(final_acc)
    return final_acc

final_acc=IFS(X_train,X_test)

import matplotlib.pyplot as plt
list_x=range(1,32)
plt.plot(list_x, final_acc)
plt.xlabel("Number of Features")
plt.ylabel("Accuracy")
plt.show()
# plt.savefig("./BT-ACC-binary.png")


